/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qar.h"

extern "C" QplugReturnStatus QarMOD(QplugArgList *);

QplugReturnStatus QarMOD  ( QplugArgList *call_list )

{
QplugReturnStatus	status;
int qar_status;

QdObject_var in_ptr;
QdObject_var  out_ptr;

char * attr_ptr;
char * string_buf;
char * out_name;

status = QPLUG_SUCCESS;


//	Unpack the input data objects
//
//	..first input item is  Any DO

 in_ptr = (*call_list)[0];


// Get name of output object

 char * slot_ptr = GetSlotText(0);
 if ( slot_ptr[0] != '\0' ) {
    out_name = QplugNewSTR(slot_ptr);
 }
 else{
    out_name = QplugNewSTR("ModObj");
    SetSlotText(0,out_name);
 }

// do arithmetic...

out_ptr = mod(in_ptr);

if (out_ptr.is_nil()) {
    QplugAppendTextDisplay (
        "Arithmetic>> This Operation is not supported for this input type\n");
    return QPLUG_FAILURE; 
}

 // Add timeline if it exists
 
 QdTimeSeq_var tt = get_timetags(in_ptr);
 if (!tt.is_nil()) set_timetags(out_ptr, tt);


 // Set QSAS essential attributes
 
 // SI_conversion

 attr_ptr = QuGetAttrText("SI_conversion", in_ptr);
 QuSetTxtAttr("SI_conversion", attr_ptr, out_ptr);
 
 
 // FIELDNAM

 attr_ptr = QuGetAttrText("FIELDNAM", in_ptr);
 if( strcmp(attr_ptr, "") != 0){
   string_buf = (char *) malloc(strlen(attr_ptr)+8);
   strcpy(string_buf,"mod: ");
   strcat(string_buf, attr_ptr);
   QuSetTxtAttr("FIELDNAM", out_name, out_ptr);
   free (string_buf);
 }
 
 // Frame
 
  // output is always a scalar
  
   QuSetTxtAttr("Frame", "scala>na", out_ptr);
 
 
 // UNITS
 
 attr_ptr = QuGetAttrText("UNITS", in_ptr);
 if( strcmp(attr_ptr, "") != 0){
   QuSetTxtAttr("UNITS", attr_ptr, out_ptr);
 }


  //	..add  the output series to the list

  call_list->push_back(out_ptr);

  QplugAppendTextDisplay ("Mod: Done\n");
  
return status;

}

