#include "qOperators.h"

// SCALAR qdOperand1
QdObject_var        GetRemainder(    QdRScalar_var qVal,           QdRScalar_var    qDivider      , QString& rqstrErrorMsg );
QdObject_var        GetRemainder(    QdRScalar_var qVal,           QdRScalarSeq_var qSeqDivider   , QString& rqstrErrorMsg );
QdObject_var        GetRemainder(    QdRScalar_var qVal,           QdRMatrix_var    qMatDivider   , QString& rqstrErrorMsg );
QdObject_var        GetRemainder(    QdRScalar_var qVal,           QdRMatrixSeq_var qMatSeqDivider, QString& rqstrErrorMsg );

// SEQUENCE OF SCALARS qdOperand1
QdObject_var  GetRemainder(       QdRScalarSeq_var qSeqVal,     QdRScalar_var    qDivider       ,   QString& rqstrErrorMsg );
QdObject_var  GetRemainder(       QdRScalarSeq_var qSeqVal,     QdRScalarSeq_var qSeqDivider    ,   QString& rqstrErrorMsg );
QdObject_var  GetRemainder(       QdRScalarSeq_var qSeqVal,     QdRMatrix_var    qMatDivider    ,   QString& rqstrErrorMsg );
QdObject_var  GetRemainder(       QdRScalarSeq_var qSeqVal,     QdRMatrixSeq_var qMatSeqDivider ,   QString& rqstrErrorMsg );

// MATRIX OF SCALARS qdOperand1
QdObject_var        GetRemainder(    QdRMatrix_var qMatVal,        QdRScalar_var    qDivider,       QString& rqstrErrorMsg );
QdObject_var        GetRemainder(    QdRMatrix_var qMatVal,        QdRScalarSeq_var qSeqDivider,    QString& rqstrErrorMsg );
QdObject_var        GetRemainder(    QdRMatrix_var qMatVal,        QdRMatrix_var    qMatDivider,    QString& rqstrErrorMsg );
QdObject_var        GetRemainder(    QdRMatrix_var qMatVal,        QdRMatrixSeq_var qMatSeqDivider, QString& rqstrErrorMsg );

// SEQUENCE OF MATRIX OF SCALARS qdOperand1
QdObject_var  GetRemainder(       QdRMatrixSeq_var qMatSeqVal,  QdRScalar_var    qDivider,       QString& rqstrErrorMsg );
QdObject_var  GetRemainder(       QdRMatrixSeq_var qMatSeqVal,  QdRScalarSeq_var qSeqDivider,    QString& rqstrErrorMsg );
QdObject_var  GetRemainder(       QdRMatrixSeq_var qMatSeqVal,  QdRMatrix_var    qMatDivider,    QString& rqstrErrorMsg );
QdObject_var  GetRemainder(       QdRMatrixSeq_var qMatSeqVal,  QdRMatrixSeq_var qMatSeqDivider, QString& rqstrErrorMsg );


template <class T> QdObject_var      ProcessRemainder( T                 rVal,
                                                        QdRScalar_var     rDivider,
                                                        QdRScalarSeq_var  rSeqDivider,
                                                        QdRMatrix_var     rMatDivider,
                                                        QdRMatrixSeq_var  rMatSeqDivider,
														QString&          rqstrErrorMsg );



QdObject_var QdRemainder( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{
   QdObject_var             qRemainder_out;

   // ( 3 ) Check whether input conformal and Time series joined
   int qar_status = QarTestConformal( qdOperand1, qdOperand2 );
   if( qar_status == QAR_ERR )
   {
   	  QcalcAppendTextDisplay( "Remainder ERROR: Input conformity test failed" );
      rqstrErrorMsg = QString( "Remainder ERROR: Input conformity test failed");
      return ( qRemainder_out );
   } 


   // qdOperand1
   QdRScalar_var    rVal              = QdRScalar_var::narrow(    qdOperand1 );
   QdRScalarSeq_var rSeqVal           = QdRScalarSeq_var::narrow( qdOperand1 );
   QdRMatrix_var    rMatVal           = QdRMatrix_var::narrow(    qdOperand1 );
   QdRMatrixSeq_var rMatSeqVal        = QdRMatrixSeq_var::narrow( qdOperand1 );
   
   // qdOperand2
   QdRScalar_var    rDivider          = QdRScalar_var::narrow(    qdOperand2 );
   QdRScalarSeq_var rSeqDivider       = QdRScalarSeq_var::narrow( qdOperand2 );
   QdRMatrix_var    rMatDivider       = QdRMatrix_var::narrow(    qdOperand2 );
   QdRMatrixSeq_var rMatSeqDivider    = QdRMatrixSeq_var::narrow( qdOperand2 );
   
      
   // ( 5 ) qdOperand1 is a scalar (float)
   if ( !rVal.is_nil() )
   {
       // Float - qdOperand1
       
       qRemainder_out = ProcessRemainder( rVal,
                                         rDivider,
                                         rSeqDivider,
                                         rMatDivider,
                                         rMatSeqDivider,
								 rqstrErrorMsg );
					 
       if ( qRemainder_out.is_nil() )
       {
           return ( qRemainder_out );
       }

   }
   else if ( !rSeqVal.is_nil() )
   {
       // Series of floats - qdOperand1
       
       qRemainder_out = ProcessRemainder( rSeqVal,
                                         rDivider,
                                         rSeqDivider,
                                         rMatDivider,
                                         rMatSeqDivider,
										 rqstrErrorMsg );
       if ( qRemainder_out.is_nil() )
       {
           return ( qRemainder_out );
       }

   } 
   else if ( !rMatVal.is_nil() )
   {
       // Matrix of scalars - qdOperand1
       
       qRemainder_out = ProcessRemainder( rMatVal,
                                         rDivider,
                                         rSeqDivider,
                                         rMatDivider,
                                         rMatSeqDivider,
										 rqstrErrorMsg );
       if ( qRemainder_out.is_nil() )
       {
           return ( qRemainder_out );
       }

   }
   else if ( !rMatSeqVal.is_nil() )
   {
      // Series of matrixes of scalars - qdOperand1
        qRemainder_out = ProcessRemainder( rMatSeqVal,
                                          rDivider,
                                          rSeqDivider,
                                          rMatDivider,
                                          rMatSeqDivider,
										  rqstrErrorMsg );
       if ( qRemainder_out.is_nil() )
       {
           return ( qRemainder_out );
       }
 
   }
   else 
   {
        // Type not being supported within this plug-in
		QcalcAppendTextDisplay( "Remainder>> ERROR - input object types for qdOperand1 not handled" );
	    rqstrErrorMsg = QString( "Remainder>> ERROR - input object types for qdOperand1 not handled");
        return ( qRemainder_out );
   }
   
   
   // ( 6 ) Add timeline: Either timeline is safe if it exists
   QdTimeSeq_var tLine = get_timetags( qdOperand1 );
   if ( tLine.is_nil() )
   {
       tLine = get_timetags( qdOperand2 );
   }

 
   // ( 7 ) Set QSAS essential attributes
   qRemainder_out->copy_xrefs_from( qdOperand1 );

   if ( !tLine.is_nil() )
   {
       set_timetags( qRemainder_out, tLine );
   }

   // ( 8.1 ) FRAME
   if ( QuIsThreeVector( qdOperand1 ) )
   {
   		QcalcAppendTextDisplay( "WARNING: Remainder treats each component independently" );
   		rqstrErrorMsg = QString( "WARNING: Remainder treats each component independently");
   }

   return ( qRemainder_out );
}



//////////////////////////////////SCALAR VALUE_IN///////////////////////////////////
QdObject_var     GetRemainder(    QdRScalar_var qVal,
                                  QdRScalar_var qDivider,
								  QString&      rqstrErrorMsg
			       )
{
    QdObject_var  rObjNull;
    QdObject_var qReminder_out;

    if ( qVal.is_nil() )
    {
		  QcalcAppendTextDisplay( "Remainder>> The scalar value for operand1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The scalar value for operand1 is NULL");
          return ( rObjNull );
    }


    if ( qDivider.is_nil() )
    {
		  QcalcAppendTextDisplay( "Remainder>> The scalar value for operand 2 (divider) is NULL");
          rqstrErrorMsg = QString( "Remainder>> The scalar value for operand 2 (divider) is NULL");
          return ( rObjNull );
    }

    float  fVal       = (float)(*qVal );
    float  fDivider   = (float)(*qDivider);
    float  fRemainder = 0.;

    QdRScalar_var  qRemainder;

    if ( fDivider != 0. )
    {
        qRemainder = new QdRScalar;
		if ( qRemainder.is_nil() )
		{
		    QcalcAppendTextDisplay( "Remainder>>Error Cannot allocate memory for remainder scalar object");
	     	rqstrErrorMsg = QString( "Remainder>>Error Cannot allocate memory for remainder scalar object");
            return ( rObjNull );
		}

        fRemainder = fmod( fVal, fDivider );
		*qRemainder = fRemainder;
    }
    else
    {
		 QcalcAppendTextDisplay( "Remainder>>Error The divider value is set to zero (0)" );
         rqstrErrorMsg = QString( "Remainder>>Error The divider value is set to zero (0)");
         return ( rObjNull );
    }

    qReminder_out = ( QdObject_var )qRemainder;
    return ( qReminder_out );
}



QdObject_var  GetRemainder( QdRScalar_var     qVal,
                            QdRScalarSeq_var  qSeqDivider,
							QString&          rqstrErrorMsg
			       )
{
     QdObject_var  rObjNull;
     QdObject_var  qReminder_out;

     if ( qVal.is_nil() )
     {
	      QcalcAppendTextDisplay( "Remainder>> The scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The scalar value for operand 1 is NULL");
          return ( rObjNull );
     }
     

     if ( qSeqDivider.is_nil() )
     {
	 	  QcalcAppendTextDisplay( "Remainder>> The sequence of scalars for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of scalars for operand 2 (divider) is NULL");
          return ( rObjNull );
     }

     
     float  fVal                     = (float)(*qVal );
     int               nData         = qSeqDivider->sequence_size();
     QdRScalarSeq_var  rSeqRemainder = new QdRScalarSeq( nData );
     float    fDivider = 0.;

     if ( rSeqRemainder.is_nil() )
     {
	 	 QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar sequence" );
         rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar sequence");
         return ( rObjNull );
     }

     for ( long i = 0; i < nData; i++ ) 
     {
	 fDivider = ( float )qSeqDivider[ i ];

	 if ( fDivider == 0. )
	 {
	      // We have to make sure that the divider is not equal to 0
	      rSeqRemainder[ i ] = 0.;
	 }
	 else
	 {
              rSeqRemainder[ i ] = fmod( *qVal , qSeqDivider[ i ] );
	 }
     }

     qReminder_out = ( QdObject_var )rSeqRemainder;
     return ( qReminder_out );	
}

QdObject_var     GetRemainder(    QdRScalar_var    qVal,
                                  QdRMatrix_var    qMatDivider,
								  QString&         rqstrErrorMsg
			      )
{
     QdObject_var qMatNullObj;
     QdObject_var qReminder_out;

     if ( qVal.is_nil() )
     {
		  QcalcAppendTextDisplay( "Remainder>> The scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The scalar value for operand 1 is NULL");
          return ( qMatNullObj );
     }

     
     if ( qMatDivider.is_nil() )
     {
	 	  QcalcAppendTextDisplay( "Remainder>> The matrix of scalars for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The matrix of scalars for operand 2 (divider) is NULL");
          return ( qMatNullObj );
     }


     
     int nRankSize = (qMatDivider->dims()).size();

#ifdef DIAG
     cout << "rank size = " << nRankSize << endl;
#endif
  

     float  fVal                     = (float)(*qVal );
     float  fDivider      = 0.;

    

     QdRMatrix_var qMatRemainder = new QdRMatrix( RMatrix( qMatDivider->dims() ) );
     if ( qMatRemainder.is_nil() )
     {
	      QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix" );
          rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix" );
          return ( qMatNullObj );
     }
     
     QdRMatrix           mat    = *qMatDivider;
     QdRMatrix::iterator itrRes = (*qMatRemainder).begin();
     for ( QdRMatrix::iterator itr = mat.begin(); itr != mat.end(); itr++ )
     {
         float fDivider = (float)(*itr);
	 float fRemainder = 0.;

	 if ( fDivider == 0. )
	 {
	     // We should make sure that the divider is not set to zero (0)
	     *itrRes = 0.;
	 }
	 else
	 {
	      // Calculate the remainder
	      *itrRes = fmod( *qVal, *itr );
	 }
	 
	 itrRes++;
     }

     qReminder_out = ( QdObject_var )qMatRemainder;
     return ( qReminder_out );
     
}

QdObject_var  GetRemainder( QdRScalar_var     qVal,
                            QdRMatrixSeq_var  qMatSeqDivider,
							QString&          rqstrErrorMsg )
{
     QdObject_var qMatNullObj;
     QdObject_var qReminder_out;

     if ( qVal.is_nil() )
     {
	      QcalcAppendTextDisplay( "Remainder>> The scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The scalar value for operand 1 is NULL");
          return ( qMatNullObj );
     }
     

     if ( qMatSeqDivider.is_nil() )
     {
	      QcalcAppendTextDisplay( "Remainder>> The series of matrix of scalars for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The series of matrix of scalars for operand 2 (divider) is NULL");
          return ( qMatNullObj );
     }

     int nRankSize = ( qMatSeqDivider[ 0 ].dims() ).size();

        
     float  fVal                     = (float)(*qVal );
     float  fDivider                 = 0.;
     float  fRemainder               = 0.;
     int    nData                    = qMatSeqDivider->sequence_size();

     
     // NOTE: We do assume that all the matrixes do have the same dimension within a
     //       sequence. Hence, only the first element of the sequence is used
     //       to instantiate the sequence of matrixes object.
     
     QdRMatrixSeq_var qMatSeqRemainder = new QdRMatrixSeq( nData,
                                                           RMatrix( qMatSeqDivider[ 0 ].dims() )
							  );
     if ( qMatSeqRemainder.is_nil() )
     {
         // This should never happen - but it could happen
		 QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence" );
         rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence" );
         return ( qMatNullObj );
     }

     for ( long nSeq = 0; nSeq < nData; nSeq++ )
     {
         QdRMatrix           mat    = ( qMatSeqDivider[   nSeq ] );
         QdRMatrix::iterator itrRes = ( qMatSeqRemainder[ nSeq ] ).begin();
	 
         for ( QdRMatrix::iterator itr = mat.begin();
	       itr != mat.end(); 
	       itr++
	     )
         {
	      float fDivider = (float)(*itr);
	      if ( fDivider == 0. )
	      {
	         // We should make sure that the divider is not set to zero ( 0 )
	         *itrRes = 0.;
	      }
	      else
	      {
	         // Calculate the remainder
	         *itrRes = fmod( *qVal, *itr );
	      }

	 
	      itrRes++;
	 }
     }
   
     qReminder_out = ( QdObject_var )qMatSeqRemainder;
     return ( qReminder_out );	
}


//////////////////////////SCALAR SEQ VALUE_IN/////////////////////////////////////
QdObject_var  GetRemainder(    QdRScalarSeq_var qSeqVal,
                               QdRScalar_var    qDivider,
							   QString&         rqstrErrorMsg )
{

    QdObject_var  rObjNull;
    QdObject_var qReminder_out;

    if ( qSeqVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of scalar value for operand 1 is NULL");
          return ( rObjNull );
    }

     
    if ( qDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The scalar value for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The scalar value for operand 2 (divider) is NULL");
          return ( rObjNull );
    }
    
    float  fDivider = (float)(*qDivider);
    if ( fDivider == 0. )
    {
	      QcalcAppendTextDisplay( "Remainder>> The scalar value for operand 2 (divider) is set to zero (0)" );
          rqstrErrorMsg = QString( "Remainder>> The scalar value for operand 2 (divider) is set to zero (0)" );
          return ( rObjNull );
    }

    
    int    nData    = qSeqVal->sequence_size();
        
    QdRScalarSeq_var  rSeqRemainder = new QdRScalarSeq( nData );
    if ( rSeqRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar series" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar series");
        return ( rObjNull );
    }

    
    try
    {
		for ( long i = 0; i < nData; i++ )
		{
			rSeqRemainder[ i ] = fmod( qSeqVal[ i ] , *qDivider );
		}
     }
     catch( Exception &e )
     {
          e.print_msg();
		  QcalcAppendTextDisplay( e.msg().c_str() );;
          rqstrErrorMsg = QString( "Remainder>> Exception thrown");
          return ( rObjNull );   
     }
     
     qReminder_out = ( QdObject_var )rSeqRemainder;
     return ( qReminder_out );	

}



QdObject_var  GetRemainder( 
                                             QdRScalarSeq_var  qSeqVal,
                                             QdRScalarSeq_var  qSeqDivider,
											 QString&          rqstrErrorMsg
			       )
{
     char   bufLog[ 100 ];
     int    nData    = qSeqVal->sequence_size();
     float  fDivider = 0.;
     
     sprintf( bufLog, "Remainder>> Size of sequence %d", nData );
     rqstrErrorMsg = QString( bufLog ); 

     QdRScalarSeq_var  rSeqRemainder = new QdRScalarSeq( nData );
     QdObject_var  rObjNull;
     QdObject_var qReminder_out;

     
     try
     {
		for ( long i = 0; i < nData; i++ )
		{
			fDivider = (float)qSeqDivider[ i ];

			if ( fDivider == 0. )
			{
				// We have to make sure that the divider is not equal to 0
				rSeqRemainder[ i ] = 0.;
			}
			else
			{
					rSeqRemainder[ i ] = fmod( qSeqVal[ i ] , qSeqDivider[ i ] );
			}
		}
     }
     catch( Exception &e )
     {
          e.print_msg();
		  QcalcAppendTextDisplay( e.msg().c_str() );;
          rqstrErrorMsg = QString( "Remainder>> Exception thrown");
          return ( rObjNull );   
     }
     
     qReminder_out = ( QdObject_var )rSeqRemainder;
     return ( qReminder_out );	

}

QdObject_var  GetRemainder( QdRScalarSeq_var qSeqVal,  
                            QdRMatrix_var    qMatDivider,
							QString&         rqstrErrorMsg )
{

    QdObject_var qMatNullObj;   

    if ( qSeqVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of scalar value for operand 1 is NULL");
          return ( qMatNullObj );
    }

     
    if ( qMatDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The scalar matrix for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The scalar matrix for operand 2 (divider) is NULL");
          return ( qMatNullObj );
    }
    

    int          nData         = qSeqVal->sequence_size();
    QdObject_var qReminder_out;
    

        
    QdRMatrixSeq_var qMatSeqRemainder = new QdRMatrixSeq( nData,
                                                          RMatrix( qMatDivider->dims() ) 
							 );
    if ( qMatSeqRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence");
        return ( qMatNullObj );
    }

    QdRMatrix           mat    = *qMatDivider;
    for ( long nSeq = 0; nSeq < nData; nSeq++ )
    {

       QdRMatrix::iterator itrRes = qMatSeqRemainder[ nSeq ].begin();
       for (
             QdRMatrix::iterator itr = mat.begin(); 
             itr != mat.end();
	         itr++
	      )
       {
         float fDivider = (float)(*itr);
	 
		if ( fDivider == 0. )
		{
			// We should make sure that the divider is not set to zero (0)
			*itrRes = 0.;
		}
		else
		{
			// Calculate the remainder
			*itrRes = fmod( qSeqVal[ nSeq ], *itr );
		}

		itrRes++;
       }

    }


    qReminder_out = ( QdObject_var )qMatSeqRemainder;
    return ( qReminder_out );
     
}

QdObject_var GetRemainder( QdRScalarSeq_var  qSeqVal,
                           QdRMatrixSeq_var  qMatSeqDivider,
						   QString&          rqstrErrorMsg  )
{
    QdObject_var qMatNullObj;

    if ( qSeqVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of scalar value for operand 1 is NULL");
          return ( qMatNullObj );
    }

     
    if ( qMatSeqDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of scalar matrix for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of scalar matrix for operand 2 (divider) is NULL");
          return ( qMatNullObj );
    }
        
    int          nData         = qSeqVal->sequence_size();
    QdObject_var qReminder_out;

    

    QdRMatrixSeq_var qMatSeqRemainder = new QdRMatrixSeq( nData, 
                                                          RMatrix( qMatSeqDivider[0].dims() )
							 );
    if ( qMatSeqRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence");
        return ( qMatNullObj );
    }
    
    for ( long nSeq = 0; nSeq < nData; nSeq++ )
    {
         QdRMatrix           mat    = ( qMatSeqDivider[   nSeq ] );
         QdRMatrix::iterator itrRes = ( qMatSeqRemainder[ nSeq ] ).begin();

         for ( QdRMatrix::iterator itr = mat.begin(); 
	       itr != mat.end();
	       itr++ 
	     )
         {
			float fDivider = (float)(*itr);
			if ( fDivider == 0. )
			{
				// We should make sure that the divider is not set to zero ( 0 )
				*itrRes = 0.;
			}
			else
			{
				// Calculate the remainder
				*itrRes = fmod( qSeqVal[ nSeq ], *itr );
			}


			itrRes++;
		 }
     }

     qReminder_out = ( QdObject_var )qMatSeqRemainder;
     return ( qReminder_out );
}




///////////////////////////SCALAR MATRIX VALUE_IN/////////////////////////////////

QdObject_var     GetRemainder(     QdRMatrix_var     qMatVal,
                                   QdRScalar_var     qDivider,
								   QString&          rqstrErrorMsg )
{
    QdObject_var      qMatNullObj;
    if ( qMatVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The matrix of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The matrix of scalar value for operand 1 is NULL");
          return ( qMatNullObj );
    }
     

    if ( qDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The scalar value for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The scalar value for operand 2 (divider) is NULL");
          return ( qMatNullObj );
    }

    QdObject_var      qReminder_out;

    float fDivider = (float)(*qDivider);
    if ( fDivider == 0. )
    {
	    QcalcAppendTextDisplay( "Remainder>> Error divider scalar value is set to zero (0)" );
        rqstrErrorMsg = QString( "Remainder>> Error divider scalar value is set to zero (0)" );
        return ( qMatNullObj );
    }

    QdRMatrix_var qMatRemainder = new QdRMatrix( RMatrix( qMatVal->dims() ) );
    if ( qMatRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix");
        return ( qMatNullObj );
    }

    QdRMatrix           mat    =   *qMatVal;
    QdRMatrix::iterator itrRes = ( *qMatRemainder ).begin();
    for ( 
             QdRMatrix::iterator itr = mat.begin();
             itr != mat.end(); 
	         itr++
	    )
    {
         // Calculate the remainder
		*itrRes = fmod( *itr, *qDivider );
		itrRes++;
    }

    qReminder_out = ( QdObject_var )qMatRemainder;
    return ( qReminder_out );	 
}


QdObject_var  GetRemainder( QdRMatrix_var     qMatVal,
                            QdRScalarSeq_var  qSeqDivider,
							QString&          rqstrErrorMsg )
{
    QdObject_var      qMatNullObj;
    if ( qMatVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The matrix of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The matrix of scalar value for operand 1 is NULL");
          return ( qMatNullObj );
    }


    if ( qSeqDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The scalar sequence for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The scalar sequence for operand 2 (divider) is NULL");
          return ( qMatNullObj );
    }
    
    float        fDivider     = 0.;
    int          nData = qSeqDivider->sequence_size();
    QdObject_var qReminder_out;
        
    QdRMatrixSeq_var qMatSeqRemainder = new QdRMatrixSeq( nData, RMatrix( qMatVal->dims() ) );
    if ( qMatSeqRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence");
        return ( qMatNullObj );
    }

    QdRMatrix           mat    =   *qMatVal;
    for ( long nSeq = 0; nSeq < nData; nSeq++ )
    {

        QdRMatrix::iterator itrRes = qMatSeqRemainder[ nSeq ].begin();

        for ( 
             QdRMatrix::iterator itr = mat.begin();
             itr != mat.end(); 
	     itr++
	       )
        {
             // Calculate the remainder
			fDivider = (float)qSeqDivider[ nSeq ];
			if ( fDivider == 0. )
			{
				*itrRes = 0;

			}
			else
			{

				*itrRes = fmod( *itr, qSeqDivider[ nSeq ] );
				}

			itrRes++;
        }

    }

      
    qReminder_out = ( QdObject_var )qMatSeqRemainder;
    return ( qReminder_out );	 

}

QdObject_var     GetRemainder( QdRMatrix_var qMatVal, 
                               QdRMatrix_var qMatDivider,
							   QString&      rqstrErrorMsg )
{

    float        fDivider     = 0.;
    QdObject_var qReminder_out;
    QdObject_var qMatNullObj;

    if ( qMatVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The matrix of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The matrix of scalar value for operand 1 is NULL");
          return ( qMatNullObj );
    }

     
    if ( qMatDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The matrix of scalar for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The matrix of scalar for operand 2 (divider) is NULL");
          return ( qMatNullObj );
    }
    

    if ( !( *qMatVal ).samesize( ( *qMatDivider ) ) )
    {
	      QcalcAppendTextDisplay( "Remainder>>Error the matrixes for operand1 and operand2 (divider) do not have the same number and dimension size" );
          rqstrErrorMsg = QString( "Remainder>>Error the matrixes for operand1 and operand2 (divider) do not have the same number and dimension size" );
	      return ( qMatNullObj );
    }

  
    QdRMatrix_var qMatRemainder = new QdRMatrix( RMatrix( qMatVal->dims() ) );
    if ( qMatRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix");
        return ( qMatNullObj );
    }

    
    QdRMatrix           matVal    =   *qMatVal;
    QdRMatrix           matDiv    =   *qMatDivider;

    QdRMatrix::iterator  itrRes = ( *qMatRemainder ).begin();
    QdRMatrix::iterator  itrVal;
    QdRMatrix::iterator  itrDiv;

   for ( 
             itrVal  = matVal.begin(), itrDiv  = matDiv.begin();
             itrVal != matVal.end() && itrDiv != matDiv.end() ; 
	         itrVal++, itrDiv++
        )
   {
             // Calculate the remainder
	     fDivider = (float)( *itrDiv );
	     if ( fDivider == 0. )
	     {
	        *itrRes = 0;
	     }
	     else
	     {
	        *itrRes = fmod( *itrVal, *itrDiv );
         }
	     
	     itrRes++;

    }
   

    qReminder_out = ( QdObject_var )qMatRemainder;
    return ( qReminder_out );
     
}

QdObject_var  GetRemainder( QdRMatrix_var     qMatVal,
                            QdRMatrixSeq_var  qMatSeqDivider,
							QString&          rqstrErrorMsg )
{
    QdObject_var qMatNullObj;

    if ( qMatVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The matrix of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The matrix of scalar value for operand 1 is NULL");
          return ( qMatNullObj );
    }

     
    if ( qMatSeqDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of matrix of scalar for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of matrix of scalar for operand 2 (divider) is NULL");
          return ( qMatNullObj );
    }
    

    int          nData        = qMatSeqDivider->sequence_size();
    float        fDivider     = 0.;
    QdObject_var qReminder_out;

        
    if ( ! (*qMatVal).samesize( qMatSeqDivider[0] ) )
    {
	    QcalcAppendTextDisplay( "Remainder>>Error - The matrixes for operand 1 and operand 2 (divider) do not have the same number and dimension size" );
        rqstrErrorMsg = QString( "Remainder>>Error - The matrixes for operand 1 and operand 2 (divider) do not have the same number and dimension size" );
	    return ( qMatNullObj );
    }
    

    QdRMatrixSeq_var qMatSeqRemainder = new QdRMatrixSeq( nData, 
                                                          RMatrix( qMatVal->dims() ) );
    if ( qMatSeqRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder sequence of scalar matrix" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder sequence of scalar matrix");
        return ( qMatNullObj );
    }

    QdRMatrix           matVal    =   *qMatVal;
    for ( long nSeq = 0; nSeq < nData; nSeq++ )
    {

        QdRMatrix::iterator itrRes    = qMatSeqRemainder[ nSeq ].begin();
	    QdRMatrix           matDiv    = qMatSeqDivider[ nSeq ];
	    QdRMatrix::iterator itrDiv;

        for ( 
             QdRMatrix::iterator itrVal = matVal.begin(), itrDiv = matDiv.begin();
             itrVal != matVal.end() && itrDiv != matDiv.end() ; 
	     itrVal++, itrDiv++
	    )
        {
             // Calculate the remainder
			fDivider = (float)( *itrDiv );
			if ( fDivider == 0. )
			{
				*itrRes = 0;

			}
			else
			{

				*itrRes = fmod( *itrVal, *itrDiv );
				}

			itrRes++;
        }

    }

    qReminder_out = ( QdObject_var )qMatSeqRemainder;
    return ( qReminder_out );
    
}



/////////////////////SCALAR MATRIX SEQUENCE VALUE_IN///////////////////////////////
QdObject_var  GetRemainder(    QdRMatrixSeq_var qMatSeqVal,  
                               QdRScalar_var    qDivider,
							   QString&         rqstrErrorMsg )
{
    QdObject_var qMatNullObj;
    
    if ( qMatSeqVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of matrix of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of matrix of scalar value for operand 1 is NULL");
          return ( qMatNullObj );
    }
     

    if ( qDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The scalar value for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The scalar value for operand 2 (divider) is NULL");
          return ( qMatNullObj );
    }

    int          nData        = qMatSeqVal->sequence_size();
    float        fDivider     = 0.;
    QdObject_var qReminder_out;

    fDivider = (float)(*qDivider);
    if ( fDivider == 0. )
    {
	    QcalcAppendTextDisplay( "Remainder>>The scalar value of the divider (operand 2 ) is set to zero (0)");
        rqstrErrorMsg = QString( "Remainder>>The scalar value of the divider is set to zero (0)" );
	    return ( qMatNullObj );
    }
    

    QdRMatrixSeq_var qMatSeqRemainder = new QdRMatrixSeq( nData, 
                                                          RMatrix( qMatSeqVal[0].dims() )
							 );
    if ( qMatSeqRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence");
        return ( qMatNullObj );
    }
    
    for ( long nSeq = 0; nSeq < nData; nSeq++ )
    {

        QdRMatrix::iterator itrRes    = qMatSeqRemainder[ nSeq ].begin();
	    QdRMatrix           matVal    = qMatSeqVal[ nSeq ];
		
        for (
                QdRMatrix::iterator itrVal = matVal.begin(); 
                itrVal != matVal.end()                     ;
	        itrVal++
	    )
        {
             // Calculate the remainder
	         *itrRes = fmod( *itrVal, *qDivider );
       	     itrRes++;
        }
    }
      
    qReminder_out = ( QdObject_var )qMatSeqRemainder;
    return ( qReminder_out );	
}



QdObject_var  GetRemainder( QdRMatrixSeq_var  qMatSeqVal,
                            QdRScalarSeq_var  qSeqDivider,
							QString&          rqstrErrorMsg )
{
    QdObject_var qMatNullObj;
    if ( qMatSeqVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of matrix of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of matrix of scalar value for operand 1 is NULL");
          return ( qMatNullObj );
    }


    if ( qSeqDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of scalars for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of scalars for operand 2 (divider) is NULL");
          return ( qMatNullObj );
    }

    int          nData        = qMatSeqVal->sequence_size();
    float        fDivider     = 0.;
    QdObject_var qReminder_out;

    
    QdRMatrixSeq_var qMatSeqRemainder = new QdRMatrixSeq( nData,
                                                          RMatrix( qMatSeqVal[0].dims() ) );

    if ( qMatSeqRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence");
        return ( qMatNullObj );
    }

    for ( long nSeq = 0; nSeq < nData; nSeq++ )
    {
        QdRMatrix::iterator itrRes    = qMatSeqRemainder[ nSeq ].begin();
	    QdRMatrix           matVal    = qMatSeqVal[ nSeq ];
		
        for (
                QdRMatrix::iterator itrVal = matVal.begin(); 
                itrVal != matVal.end()                     ;
	        itrVal++
	    )
        {
             // Calculate the remainder
			fDivider = (float)qSeqDivider[ nSeq ];
			if ( fDivider == 0. )
			{
				*itrRes = 0.;
			}
			else
			{
				*itrRes = fmod( *itrVal, qSeqDivider[ nSeq ] );
			}
			itrRes++;
        }

     }

     qReminder_out = ( QdObject_var )qMatSeqRemainder;
     return ( qReminder_out );
    
}



QdObject_var  GetRemainder(    QdRMatrixSeq_var  qMatSeqVal,
                               QdRMatrix_var     qMatDivider,
							   QString&          rqstrErrorMsg )
{
    QdObject_var qMatNullObj;
    if ( qMatSeqVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of matrix of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of matrix of scalar value for operand 1 is NULL");
          return ( qMatNullObj );
    }
     

    if ( qMatDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The matrix of scalars for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The matrix of scalars for operand 2 (divider) is NULL");
          return ( qMatNullObj );
    }

    int   nData        = qMatSeqVal->sequence_size();
    float fDivider     = 0.;
    QdObject_var qReminder_out;

    if ( !qMatSeqVal[ 0 ].samesize( (*qMatDivider) ) )
    {
	    QcalcAppendTextDisplay( "Remainder>>Error - The matrixes for operand 1 and operand 2 (divider) do not have the same number and dimension size" );
        rqstrErrorMsg = QString( "Remainder>>Error - The matrixes for operand 1 and operand 2 (divider) do not have the same number and dimension size" );
	    return ( qMatNullObj );
    }

    QdRMatrixSeq_var qMatSeqRemainder = new QdRMatrixSeq( nData, 
                                                          RMatrix( qMatDivider->dims() ) );
    if ( qMatSeqRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence");
        return ( qMatNullObj );
    }

    QdRMatrix           matDiv    = ( *qMatDivider );
    QdRMatrix::iterator itrDiv;
    
    for ( long nSeq = 0; nSeq < nData; nSeq++ )
    {
        QdRMatrix::iterator itrRes    = qMatSeqRemainder[ nSeq ].begin();
	    QdRMatrix           matVal    = qMatSeqVal[ nSeq ];

        for ( 
                QdRMatrix::iterator itrVal = matVal.begin(), itrDiv = matDiv.begin();
                itrVal != matVal.end() && itrDiv != matDiv.end()                    ; 
	            itrVal++, itrDiv++
	        )
        {
             // Calculate the remainder
			fDivider = (float)( *itrDiv );
			if ( fDivider == 0. )
			{
				*itrRes = 0.;
			}
			else
			{
				*itrRes = fmod( *itrVal, *itrDiv );
			}

       	     itrRes++;
        }

    }

    qReminder_out = ( QdObject_var )qMatSeqRemainder;
    return ( qReminder_out );
     
}




QdObject_var  GetRemainder(   QdRMatrixSeq_var   qMatSeqVal,
                              QdRMatrixSeq_var   qMatSeqDivider,
							  QString&           rqstrErrorMsg )
{

    // We do assume that all the dimension are the same accross each element
    // of the sequence of matrixes for both input objects
    QdObject_var qMatNullObj;
    if ( qMatSeqVal.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of matrix of scalar value for operand 1 is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of matrix of scalar value for operand 1 is NULL");
          return ( qMatNullObj );
    }


    if ( qMatSeqDivider.is_nil() )
    {
	      QcalcAppendTextDisplay( "Remainder>> The sequence of scalars matrix for operand 2 (divider) is NULL" );
          rqstrErrorMsg = QString( "Remainder>> The sequence of scalars matrix for operand 2 (divider) is NULL");
          return ( qMatNullObj );
    }

    int          nData        = qMatSeqVal->sequence_size();
    float        fDivider     = 0.;
    QdObject_var qReminder_out;


    if (  !qMatSeqVal[ 0 ].samesize( qMatSeqDivider[ 0 ] ) )
    {
	    QcalcAppendTextDisplay( "Remainder>>Error - The matrixes for operand 1 and operand 2 do not have the same number and dimension size" );
        rqstrErrorMsg = QString( "Remainder>>Error - The matrixes for operand 1 and operand 2 do not have the same number and dimension size" );
	    return ( qMatNullObj );
    }


    QdRMatrixSeq_var qMatSeqRemainder = new QdRMatrixSeq( nData,
                                                          RMatrix( qMatSeqVal[0].dims() ) );

    if ( qMatSeqRemainder.is_nil() )
    {
	    QcalcAppendTextDisplay( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence" );
        rqstrErrorMsg = QString( "Remainder>> Cannot allocate memory for remainder scalar matrix sequence");
        return ( qMatNullObj );
    }

    for ( long nSeq = 0; nSeq < nData; nSeq++ )
    {
        QdRMatrix::iterator itrRes    = qMatSeqRemainder[ nSeq ].begin();
	    QdRMatrix           matVal    = qMatSeqVal[ nSeq ];
	    QdRMatrix           matDiv    = qMatSeqDivider[ nSeq ];
        QdRMatrix::iterator itrDiv;

        for (
                QdRMatrix::iterator itrVal = matVal.begin(), itrDiv = matDiv.begin();
                itrVal != matVal.end() && itrDiv != matDiv.end()                    ;
	        itrVal++, itrDiv++
	    )
        {
             // Calculate the remainder
			fDivider = (float)( *itrDiv );
			if ( fDivider == 0. )
			{
				*itrRes = 0.;
			}
			else
			{
				*itrRes = fmod( *itrVal, *itrDiv );
			}

			itrRes++;
        }

    }

    qReminder_out = ( QdObject_var )qMatSeqRemainder;
    return ( qReminder_out );

}



template <class T >
QdObject_var      ProcessRemainder( T                rVal, 
                                    QdRScalar_var    rDivider,
                                    QdRScalarSeq_var rSeqDivider,
                                    QdRMatrix_var    rMatDivider,
                                    QdRMatrixSeq_var rMatSeqDivider,
									QString&          rqstrErrorMsg )
{
       QdObject_var qReminder_out;

       if ( !rDivider.is_nil() )
       {
           // ( 5.1 ) Divider is a scalar
	   // SCALAR OBJECTS
           qReminder_out = GetRemainder( rVal, rDivider, rqstrErrorMsg );
           if ( qReminder_out.is_nil() )
           {
		       QcalcAppendTextDisplay( "Remainder>> ERROR - operand 1 ( scalar value ) is set to zero" );
               rqstrErrorMsg = QString( "Remainder>> ERROR - operand 1 ( scalar value ) is set to zero");
               return ( qReminder_out );
           }
      

       }
       else if ( !rSeqDivider.is_nil() )
       {
           // ( 5.2 ) Divider is a series of scalars
			qReminder_out = GetRemainder( rVal, rSeqDivider, rqstrErrorMsg );
			if ( qReminder_out.is_nil() )
			{
				QcalcAppendTextDisplay( "Remainder>> ERROR - Calculating remainder of scalar by a scalar series" );
				rqstrErrorMsg = QString( "Remainder>> ERROR - Calculating remainder of scalar by a scalar series");
				return ( qReminder_out );
			}
       }
       else if ( !rMatDivider.is_nil() )
       {
           // ( 5.3 ) Divider is a matrix of scalars
	   		qReminder_out = GetRemainder( rVal, rMatDivider, rqstrErrorMsg );
	   		if ( qReminder_out.is_nil() )
            {
		       QcalcAppendTextDisplay( "Remainder>> ERROR - Calculating remainder of a scalar by a matrix" );
               rqstrErrorMsg = QString( "Remainder>> ERROR - Calculating remainder of a scalar by a matrix");
               return ( qReminder_out );
            }
       }
       else if ( !rMatSeqDivider.is_nil() )
       {
           // ( 5.2 ) Divider is a series of scalar matrixes
			qReminder_out = GetRemainder( rVal, rMatSeqDivider, rqstrErrorMsg );
			if ( qReminder_out.is_nil() )
			{
			    QcalcAppendTextDisplay( "Remainder>> ERROR - Calculating remainder for a sequence of matrix" );
				rqstrErrorMsg = QString( "Remainder>> ERROR - Calculating remainder for a sequence of matrix");
				return ( qReminder_out );
			}

           
       }
       else
       {
           // Type not being supported within this plug-in
		   QcalcAppendTextDisplay( "Remainder>> ERROR - input object types for divider not handled ");
	       rqstrErrorMsg = QString( "Remainder>> ERROR - input object types for divider not handled ");
           return ( qReminder_out );
       }
       
       return ( qReminder_out );
}

