#include "qOperators.h"

QdObject_var QdUnits( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{
   QdRScalar_var factor;
   QdObject_var out_ptr;
   QdObject_var SI_target;
   
   if(qdOperand1.is_nil() || qdOperand2.is_nil()  ){
     QcalcAppendTextDisplay( "Invalid input object in Unit Conversion \n" );
     return out_ptr; 
   }
 
   char *SIcTarget;
   QdString_var objStr=QdString_var::narrow(qdOperand2);
   if( objStr.is_nil() ){
      SIcTarget =  QplugNewSTR(QuGetAttrText("SI_conversion", qdOperand2));
   }
   else{
     SIcTarget = QplugNewSTR(objStr->c_str());
   }

   if( strcmp(SIcTarget, "") == 0){
     QcalcAppendTextDisplay( "Cannot get SI_conversion target for Unit Conversion\n" );
     return out_ptr; 
   }


// create output object
  
  try{
    out_ptr = QarConvertUnitsTo(qdOperand1, SIcTarget ); 
    // this creates new converted object, copies xrefs across and sets SI_conversion
  }
  catch(Exception &e){
     QcalcAppendTextDisplay( e.msg().c_str() );
     return out_ptr;  
  }
 
  if ( out_ptr.is_nil() ) {
    QcalcAppendTextDisplay("Cannot convert object to chosen target units\n RHS of target SI_conversion should be of form ...\n");
    char *attr_ptr = QuGetAttrText("SI_conversion", qdOperand1);
    char *ptr = strstr(attr_ptr, ">");
    QcalcAppendTextDisplay (&(ptr[1]));	     
    return out_ptr; 
}
 
 
 // UNITS
  char *targetUnits = QuGetAttrText("UNITS", qdOperand2);
  if(strcmp(targetUnits,"") != 0){
      QuSetTxtAttr("UNITS", targetUnits, out_ptr);    
  }
  else{  // create Units from SI_conversion
    char *SIcopy = QplugNewSTR(SIcTarget);
    if( strcmp(SIcopy, "") != 0 ){
       char *ptr = strstr(SIcopy, ">");
       if(ptr != NULL && strlen(ptr) > 1) {
         ptr[0] ='\0';
         char *newUnits = new char[strlen(&(ptr[1])) + strlen(SIcopy) + 6];
         strcpy(newUnits, &(ptr[1]));
         if(atof(SIcopy) != 1){
           strcat(newUnits, " / ");
           strcat(newUnits, SIcopy);
         }
         QuSetTxtAttr("UNITS", newUnits, out_ptr);
         delete newUnits;
       }
     }
   }


   return ( out_ptr );
}




