
/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qar.h"

extern "C" QplugReturnStatus ToBaseSI  ( QplugArgList *);

QplugReturnStatus ToBaseSI  ( QplugArgList *call_list )

{

QdRScalar_var factor;

QdObject_var in_ptr;
QdObject_var out_ptr;

char * attr_ptr;
char * out_name;

 if(call_list->size() < 1) {
    QplugAppendTextDisplay ("no inputs\n");
    return QPLUG_FAILURE; 
 } 
 
//	Unpack the input data objects
//
//	..first input item is  Any DO

//  set pointer to object 

 in_ptr = (*call_list)[0];

 if(in_ptr.is_nil() ){
    QplugAppendTextDisplay ( "Invalid input object \n");
    return QPLUG_FAILURE; 
 }
 

// Get name of output object

 char * slot_ptr = GetSlotText(0);
 if ( strcmp(slot_ptr,"") != 0 ) {
    out_name = QplugNewSTR(slot_ptr);
 }
 else{
    out_name = QplugNewSTR("ObjectInSI");
    SetSlotText(0,out_name);
 }


// create output object

  attr_ptr = QuGetAttrText("SI_conversion", in_ptr);
  if( strcmp(attr_ptr, "") != 0 ){
//     factor = new QdRScalar(QarConvFactor(attr_ptr));
      char *newAttr = new char[strlen(attr_ptr)+4];
      strcpy (newAttr, "1 >");
      const char *ptr =  strstr(attr_ptr, ">");
      strcat (newAttr, &(ptr[1]));
      out_ptr=QarConvertUnitsTo(in_ptr, newAttr, &(ptr[1]));
  }
  else{
    QplugAppendTextDisplay ( "No SI conversion metadata available for input object \n");
    return QPLUG_FAILURE; 
  }

  //	..add  the output series to the list

  call_list->push_back(out_ptr);

  QplugAppendTextDisplay ("Convert to Base SI - Done.\n");
  
return QPLUG_SUCCESS;

}

