
/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qar.h"

extern "C" QplugReturnStatus ToObjUnits  ( QplugArgList *);

QplugReturnStatus ToObjUnits  ( QplugArgList *call_list )

{

  QdRScalar_var factor;
  QdObject_var in_ptr;
  QdObject_var out_ptr;
  QdObject_var SI_target;

  char * out_name;

 if(call_list->size() < 2) {
    QplugAppendTextDisplay ("2 inputs required\n");
    return QPLUG_FAILURE; 
 } 
 
//	Unpack the input data objects
//
//	..first input item is  Any DO

//  set pointer to object 

 in_ptr = (*call_list)[0];

 SI_target = (*call_list)[1];

char *SIcTarget =  QplugNewSTR(QuGetAttrText("SI_conversion", SI_target));

char *UnitsTarget =  QplugNewSTR(QuGetAttrText("UNITS", SI_target));

 if(in_ptr.is_nil()){
    QplugAppendTextDisplay ( "Invalid input object \n");
    return QPLUG_FAILURE; 
 }
 
 if( strcmp(SIcTarget, "") == 0){
    QplugAppendTextDisplay ( "Second object has no SI_conversion \n");
    return QPLUG_FAILURE; 
 }
 if( strcmp(UnitsTarget, "") == 0){
	 QplugAppendTextDisplay ( "Second object has no UNITS attribute \n");
	 return QPLUG_FAILURE; 
 }
 
// Get name of output object

 char * slot_ptr = GetSlotText(0);
 if ( strcmp(slot_ptr,"") != 0 ) {
    out_name = QplugNewSTR(slot_ptr);
 }
 else{
    out_name = QplugNewSTR("InNewUnits");
    SetSlotText(0,out_name);
 }


// create output object
  
 try{
    out_ptr = QarConvertUnitsTo(in_ptr, SIcTarget, UnitsTarget); 
    // this creates new converted object, copies xrefs across and sets SI_conversion
 }
 catch(Exception &e){
    QplugAppendTextDisplay ( e.msg().c_str());
    return QPLUG_FAILURE;   
 }
 
if ( out_ptr.is_nil() ) {
    QplugAppendTextDisplay ("Cannot convert this object to chosen target units\n Target SI_conversion should be of form ...\n");
    char *attr_ptr = QuGetAttrText("SI_conversion", in_ptr);
    char *ptr = strstr(attr_ptr, ">");
    QplugAppendTextDisplay (&(ptr[1]));	     
    QplugAppendTextDisplay("\n");
    return QPLUG_FAILURE; 
}
 
 
 // UNITS
  char *targetUnits = QuGetAttrText("UNITS", SI_target);

  if(strcmp(targetUnits,"") == 0){  // create Units from SI_conversion
    char *SIcopy = QplugNewSTR(SIcTarget);
    if( strcmp(SIcopy, "") != 0 ){
       char *ptr = strstr(SIcopy, ">");
       if(ptr != NULL && strlen(ptr) > 1) {
         ptr[0] ='\0';
         char *newUnits = new char[strlen(&(ptr[1])) + strlen(SIcopy) + 6];
         strcpy(newUnits, &(ptr[1]));
         if(atof(SIcopy) != 1){
           strcat(newUnits, " / ");
           strcat(newUnits, SIcopy);
         }
         QuSetTxtAttr("UNITS", newUnits, out_ptr);
         delete newUnits;
       }
     }
   }


  //	..add  the output series to the list

  call_list->push_back(out_ptr);

  QplugAppendTextDisplay ("Convert to new units - Done.\n");
  
return QPLUG_SUCCESS;

}


