
/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qar.h"

extern "C" QplugReturnStatus ToUnits  ( QplugArgList *);

QplugReturnStatus ToUnits  ( QplugArgList *call_list )

{

int qar_status;
QdRScalar_var factor;

QdObject_var in_ptr;
QdObject_var out_ptr;
QdString_var SI_target;
QdString_var Units_target;

char * out_name;

 if(call_list->size() < 3) {
    QplugAppendTextDisplay ("3 inputs required\n");
    return QPLUG_FAILURE; 
 } 
 
//	Unpack the input data objects
//
//	..first input item is  Any DO

//  set pointer to object 

 in_ptr = (*call_list)[0];

 SI_target = QdString_var::narrow((*call_list)[1]);

 Units_target = QdString_var::narrow((*call_list)[2]);

 if(in_ptr.is_nil() || SI_target.is_nil() || Units_target.is_nil()){
    QplugAppendTextDisplay ( "Invalid input object \n");
    return QPLUG_FAILURE; 
 }
 
// Get name of output object

 char * slot_ptr = GetSlotText(0);
 if ( strcmp(slot_ptr,"") != 0 ) {
    out_name = QplugNewSTR(slot_ptr);
 }
 else{
    out_name = QplugNewSTR("InNewUnits");
    SetSlotText(0,out_name);
 }


// create output object
  
 try{
    out_ptr = QarConvertUnitsTo(in_ptr, SI_target->c_str(), Units_target->c_str()); 
    // this creates new converted object, copies xrefs across and sets SI_conversion
 }
 catch(Exception &e){
    QplugAppendTextDisplay ( e.msg().c_str());
    return QPLUG_FAILURE;   
 }
 
if ( out_ptr.is_nil() ) {
    QplugAppendTextDisplay ("Cannot convert this object to chosen target units\n Target SI_conversion should be of form ...\n");
    char *attr_ptr = QuGetAttrText("SI_conversion", in_ptr);
    char *ptr = strstr(attr_ptr, ">");
    QplugAppendTextDisplay (&(ptr[1]));	     
    QplugAppendTextDisplay("\n");
    return QPLUG_FAILURE; 
}

  //	..add  the output series to the list

  call_list->push_back(out_ptr);

  QplugAppendTextDisplay ("Convert to Base SI - Done.\n");
  
return QPLUG_SUCCESS;

}


