#include "PlotConfig.h"


PlotConfig::PlotConfig()
{
#if QT_VERSION < 0x040000
	QBoxLayout * mainLayout=new QBoxLayout(this, QBoxLayout::TopToBottom);
	
	mainLayout->setSpacing(QSAS_profiles->current()->GUImargins);
	mainLayout->setMargin(QSAS_profiles->current()->GUImargins);
	
// 	QGroupBox* testGroup=new QGroupBox(2, Qt::Vertical, "test", this);
// 	QLabel * toto=new QLabel("toto", testGroup);
// 	QLabel * tutu=new QLabel("tutu", testGroup);
// 	QLabel * tata=new QLabel("tata", testGroup);
// 	QLabel * titi=new QLabel("titi", testGroup);
// 	//testGroup->setLayout(testLayout);
// 
// 	mainLayout->addWidget(testGroup);
	
	QGroupBox * dropGroup=new QGroupBox(2, Qt::Horizontal, "Drag and drop default behaviour", this);
	dropGroup->setInsideSpacing(4);
	dropGroup->setInsideMargin(4);
	
	QLabel * tempLabel=new QLabel("Default when dropping a 3-vector:", dropGroup);
	new QLabel(dropGroup);

	vectorCombo=new QComboBox(dropGroup);

	vectorCombo->insertItem("1 panel: [R]");
	vectorCombo->insertItem("1 panel: [R,X,Y,Z]");
	vectorCombo->insertItem("1 panel: [X,Y,Z]");
	vectorCombo->insertItem("2 panels: [R] [X,Y,Z]");
	vectorCombo->insertItem("2 panels: [R] [Lat,Phi]");
	vectorCombo->insertItem("2 panels: [R] [Theta,Phi]");
	vectorCombo->insertItem("3 panels: [X] [Y] [Z]");
	vectorCombo->insertItem("3 panels: [R] [Lat] [Phi]");
	vectorCombo->insertItem("3 panels: [R] [Theta] [Phi]");
	vectorCombo->insertItem("4 panels: [R] [X] [Y] [Z]");
	
	new QLabel(dropGroup);
	
	tempLabel=new QLabel("Default when dropping a 3D array:", dropGroup);
	
	new QLabel(dropGroup);
	
	arrayCombo=new QComboBox(dropGroup);

	arrayCombo->insertItem("Sum over components 1 and 2");
	arrayCombo->insertItem("Sum over components 1 and 3");
	arrayCombo->insertItem("Sum over components 2 and 3");
	arrayCombo->insertItem("Preset: PEACE 3DR energies (sum)");
	arrayCombo->insertItem("Preset: PEACE 3DR energies (averaging)");
	arrayCombo->insertItem("Preset: CIS-CODIF energies (sum)");
	arrayCombo->insertItem("Other/No default behaviour");

	connect(arrayCombo, SIGNAL(activated(int)), this, SLOT(arrayChanged(int)));
	
	arrayLine=new QLineEdit(dropGroup);
	QToolTip::add(arrayLine, "Either a summation/Average over two components (SSi, SiS, iAS, iAA etc)\nor an explicit string - some presets are provided as examples");
	
	
	tempLabel=new QLabel("Default when dropping a 3D array on a trace:", dropGroup);
	
	new QLabel(dropGroup);
	
	arrayToScalarCombo=new QComboBox(dropGroup);

	arrayToScalarCombo->insertItem("Sum of components");
	arrayToScalarCombo->insertItem("Average of components");
	arrayToScalarCombo->insertItem("Other/No default behaviour");

	connect(arrayToScalarCombo, SIGNAL(activated(int)), this, SLOT(arrayToScalarChanged(int)));
	
	arrayToScalarLine=new QLineEdit(dropGroup);
	QToolTip::add(arrayToScalarLine, "Either SSS (sum), AAA (averaging)\nor an explicit string");
	
	new QLabel(dropGroup);
	
	tempLabel=new QLabel("Default when dropping a 3D array as XY:", dropGroup);
	
	new QLabel(dropGroup);
	
	arrayComboXY=new QComboBox(dropGroup);

	arrayComboXY->insertItem("Sum over component 1 at t=0");
	arrayComboXY->insertItem("Sum over component 2 at t=0");
	arrayComboXY->insertItem("Sum over component 3 at t=0");
	arrayComboXY->insertItem("Preset: PEACE 3DR energies (sum) at t=0");
	arrayComboXY->insertItem("Preset: PEACE 3DR energies (averaging) at t=0");
	arrayComboXY->insertItem("Preset: CIS-CODIF energies (sum) at t=0");
	arrayComboXY->insertItem("Other/No default behaviour");

	connect(arrayComboXY, SIGNAL(activated(int)), this, SLOT(arrayChangedXY(int)));
	
	arrayLineXY=new QLineEdit(dropGroup);
	QToolTip::add(arrayLineXY, "Either a summation/Average over a component (iiSt, iiAt, Siit etc) \nor an explicit string - some presets are provided\n Always uses record 0");
	
	tempLabel=new QLabel("Default when dropping a 3D array on an XY trace:", dropGroup);
	
	new QLabel(dropGroup);
	
	arrayToScalarComboXY=new QComboBox(dropGroup);

	arrayToScalarComboXY->insertItem("Sum over components 2 and 3 at t=0");
	arrayToScalarComboXY->insertItem("Sum over components 1 and 3 at t=0");
	arrayToScalarComboXY->insertItem("Sum over components 1 and 2 at t=0");
	arrayToScalarComboXY->insertItem("Average of components 2 and 3 at t=0");
	arrayToScalarComboXY->insertItem("Average of components 1 and 3 at t=0");
	arrayToScalarComboXY->insertItem("Average of components 1 and 2 at t=0");
	arrayToScalarComboXY->insertItem("Other/No default behaviour");

	connect(arrayToScalarComboXY, SIGNAL(activated(int)), this, SLOT(arrayToScalarChangedXY(int)));
	
	arrayToScalarLineXY=new QLineEdit(dropGroup);
	QToolTip::add(arrayToScalarLineXY, "Either a summation/Average over 2 components (iSSt, iAAt, SSit etc) \nor an explicit string - some presets are provided as examples\n Always uses record 0");
	
	mainLayout->addWidget(dropGroup);
	
	
	QGroupBox * plotGroup=new QGroupBox(2, Qt::Horizontal, "Default plot settings", this);
	
	plotGroup->setInsideSpacing(4);
	plotGroup->setInsideMargin(4);
	
	new QLabel("Time labels format:", plotGroup);
	
	timeRepCombo=new QComboBox(plotGroup);

	timeRepCombo->insertItem("Colon-separated: H:M:S");
	timeRepCombo->insertItem("Hour/Min/Sec: HhMmSs");
	
	mainLayout->addWidget(plotGroup);
	
	QGroupBox * pageGroup=new QGroupBox(6, Qt::Horizontal, "Default page settings", this);
	pageGroup->setInsideSpacing(4);
	pageGroup->setInsideMargin(4);

	new QLabel("Size:", pageGroup);
	
	pageSizeCombo=new QComboBox(pageGroup);

	pageSizeCombo->insertItem("A4");
	pageSizeCombo->insertItem("Custom");
	pageSizeCombo->insertItem("Executive");
	pageSizeCombo->insertItem("Legal");
	pageSizeCombo->insertItem("Letter");
	pageSizeCombo->insertItem("Default");

	connect(pageSizeCombo, SIGNAL(activated(int)), this, SLOT(pageSizeChanged(int)));
	
	new QLabel("Orientation:", pageGroup);
	
	orientationCombo=new QComboBox(pageGroup);

	orientationCombo->insertItem("Portrait");
	orientationCombo->insertItem("Landscape");
	
	new QLabel("Resolution:", pageGroup);
	
	pageDPICombo=new QComboBox(pageGroup);

	pageDPICombo->insertItem("72 dpi");
	pageDPICombo->insertItem("150 dpi");
	pageDPICombo->insertItem("300 dpi");
	pageDPICombo->insertItem("600 dpi");
	
	connect(pageDPICombo, SIGNAL(activated(int)), this, SLOT(pageDPIChanged(int)));

	new QLabel("Width:", pageGroup);
	
	widthLine=new QLineEdit(pageGroup);
	widthLine->setValidator(new QDoubleValidator(widthLine));
		
	new QLabel("Height:", pageGroup);
	
	heightLine=new QLineEdit(pageGroup);
	heightLine->setValidator(new QDoubleValidator(heightLine));
	
	unitsCombo=new QComboBox(pageGroup);

	unitsCombo->insertItem("pixels");
	unitsCombo->insertItem("inches");
	unitsCombo->insertItem("cm");
	unitsCombo->insertItem("mm");
	unitsCombo->insertItem("PS points");
	
	connect(unitsCombo, SIGNAL(activated(int)), this, SLOT(unitsChanged(int)));

	kprinterCheck=new QCheckBox("Print manager: use kprinter rather than lpr (Linux only):", pageGroup);

#if defined(WINDOWS) || defined(Q_OS_MACX)
	kprinterCheck->setEnabled(false);
#endif

	mainLayout->addWidget(pageGroup);
	
	previous_units=0;
	previous_dpi=72.;
#else // Qt4
	QGridLayout * mainLayout=new QGridLayout(this);
	
	QGroupBox * dropGroup=new QGroupBox(this);
	dropGroup->setTitle("Drag and drop default behaviour");
	QGridLayout * dropLayout=new QGridLayout(dropGroup);
	
	QLabel * tempLabel=new QLabel("Default when dropping a 3-vector:", dropGroup);

	tempLabel->setWordWrap(true);

	dropLayout->addWidget(tempLabel, 0, 0);
	
	vectorCombo=new QComboBox(dropGroup);

	vectorCombo->addItem("1 panel: [R]");
	vectorCombo->addItem("1 panel: [R,X,Y,Z]");
	vectorCombo->addItem("1 panel: [X,Y,Z]");
	vectorCombo->addItem("2 panels: [R] [X,Y,Z]");
	vectorCombo->addItem("2 panels: [R] [Lat,Phi]");
	vectorCombo->addItem("2 panels: [R] [Theta,Phi]");
	vectorCombo->addItem("3 panels: [X] [Y] [Z]");
	vectorCombo->addItem("3 panels: [R] [Lat] [Phi]");
	vectorCombo->addItem("3 panels: [R] [Theta] [Phi]");
	vectorCombo->addItem("4 panels: [R] [X] [Y] [Z]");

	
	dropLayout->addWidget(vectorCombo, 1, 0);
	
	tempLabel=new QLabel("Default when dropping a 3D array:", dropGroup);

	tempLabel->setWordWrap(true);

	dropLayout->addWidget(tempLabel, 3, 0);
	
	arrayCombo=new QComboBox(dropGroup);

	arrayCombo->addItem("Sum over components 1 & 2");
	arrayCombo->addItem("Sum over components 1 & 3");
	arrayCombo->addItem("Sum over components 2 & 3");
	arrayCombo->addItem("Preset: PEACE 3DRL data (sum)");
	arrayCombo->addItem("Preset: PEACE 3DRL data (averaging)");
	arrayCombo->addItem("Preset: CIS-CODIF energies (sum)");
	arrayCombo->addItem("Other/No default behaviour");

	dropLayout->addWidget(arrayCombo, 4, 0);

	connect(arrayCombo, SIGNAL(currentIndexChanged(int)), this, SLOT(arrayChanged(int)));

	
	arrayLine=new QLineEdit(dropGroup);
	QToolTip::add(arrayLine, "Either a summation over two components (SSi, SiS or iSS)\nor an explicit string - some presets are provided");
	dropLayout->addWidget(arrayLine, 4, 1);
	
	
	tempLabel=new QLabel("Default when dropping a 3D array on a trace:", dropGroup);

	tempLabel->setWordWrap(true);

	dropLayout->addWidget(tempLabel, 5, 0);
	
	arrayToScalarCombo=new QComboBox(dropGroup);

	arrayToScalarCombo->addItem("Sum of components");
	arrayToScalarCombo->addItem("Average of components");
	arrayToScalarCombo->addItem("Other/No default behaviour");

	dropLayout->addWidget(arrayToScalarCombo, 6, 0);

	connect(arrayToScalarCombo, SIGNAL(currentIndexChanged(int)), this, SLOT(arrayToScalarChanged(int)));

	
	arrayToScalarLine=new QLineEdit(dropGroup);
	QToolTip::add(arrayToScalarLine, "Either SSS (sum), AAA (averaging)\nor an explicit string");
	dropLayout->addWidget(arrayToScalarLine, 6, 1);

	
	tempLabel=new QLabel("Default when dropping a 3D array as XY:", dropGroup);
	tempLabel->setWordWrap(true);
	dropLayout->addWidget(tempLabel, 7, 0);
	
	arrayComboXY=new QComboBox(dropGroup);

	arrayComboXY->addItem("Sum over component 1 at t=0");
	arrayComboXY->addItem("Sum over component 2 at t=0");
	arrayComboXY->addItem("Sum over component 3 at t=0");
	arrayComboXY->addItem("Preset: PEACE 3DR energies (sum) at t=0");
	arrayComboXY->addItem("Preset: PEACE 3DR energies (averaging) at t=0");
	arrayComboXY->addItem("Preset: CIS-CODIF energies (sum) at t=0");
	arrayComboXY->addItem("Other/No default behaviour");

	dropLayout->addWidget(arrayComboXY, 8, 0);

	connect(arrayComboXY, SIGNAL(currentIndexChanged(int)), this, SLOT(arrayChangedXY(int)));

	
	arrayLineXY=new QLineEdit(dropGroup);
	QToolTip::add(arrayLineXY, "Either a summation/Average over a component (iiSt, iiAt, Siit etc) \nor an explicit string - some presets are provided\n Always uses record 0");
	dropLayout->addWidget(arrayLineXY, 8, 1);
	
	
	tempLabel=new QLabel("Default when dropping a 3D array on an XY trace:", dropGroup);

	tempLabel->setWordWrap(true);

	dropLayout->addWidget(tempLabel, 9, 0);
	
	arrayToScalarComboXY=new QComboBox(dropGroup);

	arrayToScalarComboXY->addItem("Sum over components 2 and 3 at t=0");
	arrayToScalarComboXY->addItem("Sum over components 1 and 3 at t=0");
	arrayToScalarComboXY->addItem("Sum over components 1 and 2 at t=0");
	arrayToScalarComboXY->addItem("Average of components 2 and 3 at t=0");
	arrayToScalarComboXY->addItem("Average of components 1 and 3 at t=0");
	arrayToScalarComboXY->addItem("Average of components 1 and 2 at t=0");
	arrayToScalarComboXY->addItem("Other/No default behaviour");

	dropLayout->addWidget(arrayToScalarComboXY, 10, 0);

	connect(arrayToScalarComboXY, SIGNAL(currentIndexChanged(int)), this, SLOT(arrayToScalarChangedXY(int)));

	
	arrayToScalarLineXY=new QLineEdit(dropGroup);
	QToolTip::add(arrayToScalarLineXY, "Either a summation/Average over 2 components (iSSt, iAAt, SSit etc) \nor an explicit string - some presets are provided as examples\n Always uses record 0");
	dropLayout->addWidget(arrayToScalarLineXY, 10, 1);

	mainLayout->addWidget(dropGroup, 0, 0);
	
	QGroupBox * plotGroup=new QGroupBox(this);
	plotGroup->setTitle("Default plot settings");
	QGridLayout * plotLayout=new QGridLayout(plotGroup);
	
	plotLayout->addWidget(new QLabel("Time labels format:", plotGroup), 0, 0);
	timeRepCombo=new QComboBox(plotGroup);

	timeRepCombo->addItem("Colon-separated: H:M:S");
	timeRepCombo->addItem("Hour/Min/Sec: HhMmSs");

	plotLayout->addWidget(timeRepCombo, 0, 1);
	
	mainLayout->addWidget(plotGroup, 1, 0);
	
	QGroupBox * pageGroup=new QGroupBox(this);
	pageGroup->setTitle("Default page settings");
	QGridLayout * pageLayout=new QGridLayout(pageGroup);
	
	pageLayout->addWidget(new QLabel("Size:", pageGroup), 0, 0, Qt::AlignRight);
	
	pageSizeCombo=new QComboBox(pageGroup);

	pageSizeCombo->addItem("A4");
	pageSizeCombo->addItem("Custom");
	pageSizeCombo->addItem("Executive");
	pageSizeCombo->addItem("Legal");
	pageSizeCombo->addItem("Letter");
	pageSizeCombo->addItem("Default");

	pageLayout->addWidget(pageSizeCombo, 0, 1);

	connect(pageSizeCombo, SIGNAL(currentIndexChanged(int)), this, SLOT(pageSizeChanged(int)));

	
	pageLayout->addWidget(new QLabel("Orientation:", pageGroup), 0, 3, Qt::AlignRight);
	
	orientationCombo=new QComboBox(pageGroup);

	orientationCombo->addItem("Portrait");
	orientationCombo->addItem("Landscape");

	pageLayout->addWidget(orientationCombo, 0, 4);
	
	pageLayout->addWidget(new QLabel("Resolution:", pageGroup), 0, 5, Qt::AlignRight);
	
	pageDPICombo=new QComboBox(pageGroup);

	pageDPICombo->addItem("72 dpi");
	pageDPICombo->addItem("150 dpi");
	pageDPICombo->addItem("300 dpi");
	pageDPICombo->addItem("600 dpi");

	pageLayout->addWidget(pageDPICombo, 0, 6);
	
	connect(pageDPICombo, SIGNAL(currentIndexChanged(int)), this, SLOT(pageDPIChanged(int)));
	
	pageLayout->addWidget(new QLabel("Width:", pageGroup), 1, 0, Qt::AlignRight);
	
	widthLine=new QLineEdit(pageGroup);
	widthLine->setValidator(new QDoubleValidator(widthLine));
	pageLayout->addWidget(widthLine, 1, 1);
		
	pageLayout->addWidget(new QLabel("Height:", pageGroup), 1, 2, Qt::AlignRight);
	
	heightLine=new QLineEdit(pageGroup);
	heightLine->setValidator(new QDoubleValidator(heightLine));
	pageLayout->addWidget(heightLine, 1, 3);
	
	unitsCombo=new QComboBox(pageGroup);

	unitsCombo->addItem("pixels");
	unitsCombo->addItem("inches");
	unitsCombo->addItem("cm");
	unitsCombo->addItem("mm");
	unitsCombo->addItem("PS points");

	pageLayout->addWidget(unitsCombo, 1, 4);
	
	connect(unitsCombo, SIGNAL(currentIndexChanged(int)), this, SLOT(unitsChanged(int)));

	kprinterCheck=new QCheckBox("Print manager: use kprinter rather than lpr (Linux only):", pageGroup);

	pageLayout->addWidget(kprinterCheck, 2, 0, 1, 4);

#if defined(WINDOWS) || defined(Q_OS_MACX)
	kprinterCheck->setEnabled(false);
#endif
		
	mainLayout->addWidget(pageGroup, 2, 0);
	
	previous_units=0;
	previous_dpi=72.;
#endif
}

void PlotConfig::updateProfile(QProfile * p)
{

#if QT_VERSION < 0x040000
	switch(vectorCombo->currentItem())
#else
	switch(vectorCombo->currentIndex())
#endif
	{
		case 1:
			p->Vector3D="RXYZ";
			break;
		case 2:
			p->Vector3D="XYZ";
			break;
		case 3:
			p->Vector3D="R_XYZ";
			break;
		case 4:
			p->Vector3D="R_LP";
			break;
		case 5:
			p->Vector3D="R_TP";
			break;
		case 6:
			p->Vector3D="X_Y_Z";
			break;
		case 7:
			p->Vector3D="R_L_P";
			break;
		case 8:
			p->Vector3D="R_T_P";
			break;
		case 9:
			p->Vector3D="R_X_Y_Z";
			break;
		case 0:
		default:
			p->Vector3D="R";
			break;
	}
	
	p->Array3D=arrayLine->text();
	
	p->Array3DtoScalar=arrayToScalarLine->text();
	
	p->Array3DXY=arrayLineXY->text();
	
	p->Array3DtoScalarXY=arrayToScalarLineXY->text();
	
#if QT_VERSION < 0x040000
	switch(timeRepCombo->currentItem())
#else
	switch(timeRepCombo->currentIndex())
#endif
	{
		case 1:
			p->TimeRep="HMS";
			break;
		case 0:
		default:
			p->TimeRep="Colon";
			break;
	}

#if QT_VERSION < 0x040000
	switch(pageSizeCombo->currentItem())
#else
	switch(pageSizeCombo->currentIndex())
#endif
	{
		case 1:
			p->PageSize="Custom";
			break;
		case 2:
			p->PageSize="Executive";
			break;
		case 3:
			p->PageSize="Legal";
			break;
		case 4:
			p->PageSize="Letter";
			break;
		case 5:
			p->PageSize="Default";
			break;
		case 0:
		default:
			p->PageSize="A4";
			break;
	}
	
	p->PageDPI=(int)getCurrentDPI();
	
#if QT_VERSION < 0x040000
	switch(orientationCombo->currentItem())
#else
	switch(orientationCombo->currentIndex())
#endif
	{
		case 0:
			p->PageOrientation="Portrait";
			break;
		case 1:
		default:
			p->PageOrientation="Landscape";
			break;
	}
		double _conversion_factors[5]={getCurrentDPI(),1,2.54,25.4,getCurrentDPI()};
	p->PageWidth=widthLine->text().toDouble()/_conversion_factors[unitsCombo->currentItem()];
	p->PageHeight=heightLine->text().toDouble()/_conversion_factors[unitsCombo->currentItem()];
	
	p->UseKPrinter=kprinterCheck->isChecked();
}

void PlotConfig::setSelectedProfile(QProfile * p)
{

#if QT_VERSION < 0x040000
	QString strVector3D=p->Vector3D;
	if(strVector3D=="RXYZ") vectorCombo->setCurrentItem(1);
	else if(strVector3D=="XYZ") vectorCombo->setCurrentItem(2);
	else if(strVector3D=="R_XYZ") vectorCombo->setCurrentItem(3);
	else if(strVector3D=="R_LP") vectorCombo->setCurrentItem(4);
	else if(strVector3D=="R_TP") vectorCombo->setCurrentItem(5);
	else if(strVector3D=="X_Y_Z") vectorCombo->setCurrentItem(6);
	else if(strVector3D=="R_L_P") vectorCombo->setCurrentItem(7);
	else if(strVector3D=="R_T_P") vectorCombo->setCurrentItem(8);
	else if(strVector3D=="R_X_Y_Z") vectorCombo->setCurrentItem(9);
	else vectorCombo->setCurrentItem(0);
	
	QString strArray3D=p->Array3D;
	if(strArray3D=="SSi") arrayCombo->setCurrentItem(0);
	else if(strArray3D=="SiS") arrayCombo->setCurrentItem(1);
	else if(strArray3D=="iSS") arrayCombo->setCurrentItem(2);
	else if(strArray3D==ARRAY_PEACE_SUM) arrayCombo->setCurrentItem(3);
	else if(strArray3D==ARRAY_PEACE_AVE) arrayCombo->setCurrentItem(4);
	else if(strArray3D==ARRAY_CODIF_SUM) arrayCombo->setCurrentItem(5);
	else
	{
		arrayCombo->setCurrentItem(6);
	}
	arrayLine->setText(strArray3D);

	QString strArray3DtoScalar=p->Array3DtoScalar;
	if(strArray3DtoScalar=="SSS") arrayToScalarCombo->setCurrentItem(0);
	else if(strArray3DtoScalar=="AAA") arrayToScalarCombo->setCurrentItem(1);
	else
	{
		arrayToScalarCombo->setCurrentItem(2);
	}
	arrayToScalarLine->setText(strArray3DtoScalar);
	
	QString strArray3DXY=p->Array3DXY;
	if(strArray3DXY=="Siit") arrayComboXY->setCurrentItem(0);
	else if(strArray3DXY=="iSit") arrayComboXY->setCurrentItem(1);
	else if(strArray3DXY=="iiSt") arrayComboXY->setCurrentItem(2);
	else if(strArray3DXY==ARRAY_PEACE_SUM_XY) arrayComboXY->setCurrentItem(3);
	else if(strArray3DXY==ARRAY_PEACE_AVE_XY) arrayComboXY->setCurrentItem(4);
	else if(strArray3DXY==ARRAY_CODIF_SUM_XY) arrayComboXY->setCurrentItem(5);
	else
	{
		arrayComboXY->setCurrentItem(6);
	}
	arrayLineXY->setText(strArray3DXY);
	
	QString strArray3DtoScalarXY=p->Array3DtoScalarXY;
	if(strArray3DtoScalarXY=="iSSt") arrayToScalarComboXY->setCurrentItem(0);
	else if(strArray3DtoScalarXY=="SiSt") arrayToScalarComboXY->setCurrentItem(1);
	else if(strArray3DtoScalarXY=="SSit") arrayToScalarComboXY->setCurrentItem(2);
	else if(strArray3DtoScalarXY=="iAAt") arrayToScalarComboXY->setCurrentItem(3);
	else if(strArray3DtoScalarXY=="AiAt") arrayToScalarComboXY->setCurrentItem(4);
	else if(strArray3DtoScalarXY=="AAit") arrayToScalarComboXY->setCurrentItem(5);
	else
	{
		arrayToScalarComboXY->setCurrentItem(6);
	}
	arrayToScalarLineXY->setText(strArray3DtoScalarXY);
	
	QString strTimeRep=p->TimeRep;
	if(strTimeRep=="HMS") timeRepCombo->setCurrentItem(1);
	else timeRepCombo->setCurrentItem(0);
	
	QString strPageSize=p->PageSize;
	if(strPageSize=="A4") {pageSizeCombo->setCurrentItem(0); widthLine->setEnabled(false); heightLine->setEnabled(false);}
	else if(strPageSize=="Executive") {pageSizeCombo->setCurrentItem(2); widthLine->setEnabled(false); heightLine->setEnabled(false);}
	else if(strPageSize=="Legal") {pageSizeCombo->setCurrentItem(3); widthLine->setEnabled(false); heightLine->setEnabled(false);}
	else if(strPageSize=="Letter") {pageSizeCombo->setCurrentItem(4); widthLine->setEnabled(false); heightLine->setEnabled(false);}
	else if(strPageSize=="Default") {pageSizeCombo->setCurrentItem(5); widthLine->setEnabled(false); heightLine->setEnabled(false);}
	else  {pageSizeCombo->setCurrentItem(1);  widthLine->setEnabled(true); heightLine->setEnabled(true);} //Custom
	
	int pageDPI=p->PageDPI;
	switch(pageDPI)
	{
		case 150: pageDPICombo->setCurrentItem(1); break;
		case 300: pageDPICombo->setCurrentItem(2); break;
		case 600: pageDPICombo->setCurrentItem(3); break;
		default: pageDPICombo->setCurrentItem(0); break;
	}
	
	QString strPageOrientation=p->PageOrientation;
	if(strPageOrientation=="Portrait") orientationCombo->setCurrentItem(0);
	else orientationCombo->setCurrentItem(1);
	
	double _conversion_factors[5]={getCurrentDPI(),1,2.54,25.4,getCurrentDPI()};
	widthLine->setText(QString().setNum(p->PageWidth*_conversion_factors[unitsCombo->currentItem()]));
	heightLine->setText(QString().setNum(p->PageHeight*_conversion_factors[unitsCombo->currentItem()]));
	
	kprinterCheck->setChecked(p->UseKPrinter);
#else
	QString strVector3D=p->Vector3D;
	if(strVector3D=="RXYZ") vectorCombo->setCurrentIndex(1);
	else if(strVector3D=="XYZ") vectorCombo->setCurrentIndex(2);
	else if(strVector3D=="R_XYZ") vectorCombo->setCurrentIndex(3);
	else if(strVector3D=="R_LP") vectorCombo->setCurrentIndex(4);
	else if(strVector3D=="R_TP") vectorCombo->setCurrentIndex(5);
	else if(strVector3D=="X_Y_Z") vectorCombo->setCurrentIndex(6);
	else if(strVector3D=="R_L_P") vectorCombo->setCurrentIndex(7);
	else if(strVector3D=="R_T_P") vectorCombo->setCurrentIndex(8);
	else if(strVector3D=="R_X_Y_Z") vectorCombo->setCurrentIndex(9);
	else vectorCombo->setCurrentIndex(0);
	
	QString strArray3D=p->Array3D;
	if(strArray3D=="SSi") arrayCombo->setCurrentItem(0);
	else if(strArray3D=="SiS") arrayCombo->setCurrentItem(1);
	else if(strArray3D=="iSS") arrayCombo->setCurrentItem(2);
	else if(strArray3D==ARRAY_PEACE_SUM) arrayCombo->setCurrentItem(3);
	else if(strArray3D==ARRAY_PEACE_AVE) arrayCombo->setCurrentItem(4);
	else if(strArray3D==ARRAY_CODIF_SUM) arrayCombo->setCurrentItem(5);
	else
	{
		arrayCombo->setCurrentItem(6);
	}
	arrayLine->setText(strArray3D);

	QString strArray3DtoScalar=p->Array3DtoScalar;
	if(strArray3DtoScalar=="SSS") arrayToScalarCombo->setCurrentItem(0);
	else if(strArray3DtoScalar=="AAA") arrayToScalarCombo->setCurrentItem(1);
	else
	{
		arrayToScalarCombo->setCurrentItem(2);
	}
	arrayToScalarLine->setText(strArray3DtoScalar);
	
	QString strArray3DXY=p->Array3DXY;
	if(strArray3DXY=="Siit") arrayComboXY->setCurrentItem(0);
	else if(strArray3DXY=="iSit") arrayComboXY->setCurrentItem(1);
	else if(strArray3DXY=="iiSt") arrayComboXY->setCurrentItem(2);
	else if(strArray3DXY==ARRAY_PEACE_SUM_XY) arrayComboXY->setCurrentItem(3);
	else if(strArray3DXY==ARRAY_PEACE_AVE_XY) arrayComboXY->setCurrentItem(4);
	else if(strArray3DXY==ARRAY_CODIF_SUM_XY) arrayComboXY->setCurrentItem(5);
	else
	{
		arrayComboXY->setCurrentItem(6);
	}
	arrayLineXY->setText(strArray3DXY);
	
	QString strArray3DtoScalarXY=p->Array3DtoScalarXY;
	if(strArray3DtoScalarXY=="iSSt") arrayToScalarComboXY->setCurrentItem(0);
	else if(strArray3DtoScalarXY=="SiSt") arrayToScalarComboXY->setCurrentItem(1);
	else if(strArray3DtoScalarXY=="SSit") arrayToScalarComboXY->setCurrentItem(2);
	else if(strArray3DtoScalarXY=="iAAt") arrayToScalarComboXY->setCurrentItem(3);
	else if(strArray3DtoScalarXY=="AiAt") arrayToScalarComboXY->setCurrentItem(4);
	else if(strArray3DtoScalarXY=="AAit") arrayToScalarComboXY->setCurrentItem(5);
	else
	{
		arrayToScalarComboXY->setCurrentItem(6);
	}
	arrayToScalarLineXY->setText(strArray3DtoScalarXY);
	
	QString strTimeRep=p->TimeRep;
	if(strTimeRep=="HMS") timeRepCombo->setCurrentIndex(1);
	else timeRepCombo->setCurrentIndex(0);
	
	QString strPageSize=p->PageSize;
	if(strPageSize=="A4") {pageSizeCombo->setCurrentIndex(0); widthLine->setEnabled(false); heightLine->setEnabled(false);}
	else if(strPageSize=="Executive") {pageSizeCombo->setCurrentIndex(2); widthLine->setEnabled(false); heightLine->setEnabled(false);}
	else if(strPageSize=="Legal") {pageSizeCombo->setCurrentIndex(3); widthLine->setEnabled(false); heightLine->setEnabled(false);}
	else if(strPageSize=="Letter") {pageSizeCombo->setCurrentIndex(4); widthLine->setEnabled(false); heightLine->setEnabled(false);}
	else if(strPageSize=="Default") {pageSizeCombo->setCurrentIndex(5); widthLine->setEnabled(false); heightLine->setEnabled(false);}
	else  {pageSizeCombo->setCurrentIndex(1);  widthLine->setEnabled(true); heightLine->setEnabled(true);} //Custom
	
	int pageDPI=p->PageDPI;
	switch(pageDPI)
	{
		case 150: pageDPICombo->setCurrentIndex(1); break;
		case 300: pageDPICombo->setCurrentIndex(2); break;
		case 600: pageDPICombo->setCurrentIndex(3); break;
		default: pageDPICombo->setCurrentIndex(0); break;
	}
	
	QString strPageOrientation=p->PageOrientation;
	if(strPageOrientation=="Portrait") orientationCombo->setCurrentIndex(0);
	else orientationCombo->setCurrentIndex(1);
	
	double _conversion_factors[5]={getCurrentDPI(),1,2.54,25.4,getCurrentDPI()};
	widthLine->setText(QString().setNum(p->PageWidth*_conversion_factors[unitsCombo->currentIndex()]));
	heightLine->setText(QString().setNum(p->PageHeight*_conversion_factors[unitsCombo->currentIndex()]));
	
	kprinterCheck->setChecked(p->UseKPrinter);
#endif

}


void PlotConfig::arrayChanged(int index)
{
	switch(index)
	{
		case 0:
			arrayLine->setText("SSi");
			break;
		case 1:
			arrayLine->setText("SiS");
			break;
		case 2:
			arrayLine->setText("iSS");
			break;
		case 3:
			arrayLine->setText(ARRAY_PEACE_SUM);
			break;
		case 4:
			arrayLine->setText(ARRAY_PEACE_AVE);
			break;
		case 5:
			arrayLine->setText(ARRAY_CODIF_SUM);
			break;
		default:
			arrayLine->setText("");
			break;
	}
}

void PlotConfig::arrayToScalarChanged(int index)
{
	switch(index)
	{
		case 0:
			arrayToScalarLine->setText("SSS");
			break;
		case 1:
			arrayToScalarLine->setText("AAA");
			break;
		default:
			arrayToScalarLine->setText("");
			break;
	}
}

void PlotConfig::arrayChangedXY(int index)
{
	switch(index)
	{
		case 0:
			arrayLineXY->setText("Siit");
			break;
		case 1:
			arrayLineXY->setText("iSit");
			break;
		case 2:
			arrayLineXY->setText("iiSt");
			break;
		case 3:
			arrayLineXY->setText(ARRAY_PEACE_SUM_XY);
			break;
		case 4:
			arrayLineXY->setText(ARRAY_PEACE_AVE_XY);
			break;
		case 5:
			arrayLineXY->setText(ARRAY_CODIF_SUM_XY);
			break;
		default:
			arrayLineXY->setText("");
			break;
	}
}

void PlotConfig::arrayToScalarChangedXY(int index)
{
	switch(index)
	{
		case 0:
			arrayToScalarLineXY->setText("iSSt");
			break;
		case 1:
			arrayToScalarLineXY->setText("SiSt");
			break;
		case 2:
			arrayToScalarLineXY->setText("SSit");
			break;
		case 3:
			arrayToScalarLineXY->setText("iAAt");
			break;
		case 4:
			arrayToScalarLineXY->setText("AiAt");
			break;
		case 5:
			arrayToScalarLineXY->setText("AAit");
			break;
		default:
			arrayToScalarLineXY->setText("");
			break;
	}
}


void PlotConfig::pageSizeChanged(int index)
{
	double _conversion_factors[5]={getCurrentDPI(),1,2.54,25.4,getCurrentDPI()};
	double _width_in_inches[6]={8.3,8.5,7.5,8.5,8.5,0.};
	double _height_in_inches[6]={11.694,9,10.,14,11,0.}; //TODO keep synched with qpui_page.cc
	
#if QT_VERSION < 0x040000
	double width=_width_in_inches[pageSizeCombo->currentItem()];
	double height=_height_in_inches[pageSizeCombo->currentItem()];
	double conv=_conversion_factors[unitsCombo->currentItem()];
#else
	double width=_width_in_inches[pageSizeCombo->currentIndex()];
	double height=_height_in_inches[pageSizeCombo->currentIndex()];
	double conv=_conversion_factors[unitsCombo->currentIndex()];
#endif
	
	width=width*conv;
	height=height*conv;
	widthLine->setText(QString().setNum(width));
	heightLine->setText(QString().setNum(height));
	
	if(index==1) //custom
	{
		widthLine->setEnabled(true);
		heightLine->setEnabled(true);
	}
	else
	{
		widthLine->setEnabled(false);
		heightLine->setEnabled(false);
	}
}

void PlotConfig::unitsChanged(int index)
{
	double _conversion_factors[5]={getCurrentDPI(),1,2.54,25.4,getCurrentDPI()};
	double _width_in_inches[6]={8.3,8.5,7.5,8.5,8.5,0.};
	double _height_in_inches[6]={11.694,9,10.,14,11,0.}; //TODO keep synched with qpui_page.cc
	
	double width=widthLine->text().toDouble();
	double height=heightLine->text().toDouble();
	
	//conversion into inches
	double conv=_conversion_factors[previous_units];
	width=width/conv;
	height=height/conv;
	
	//conversion into new units
	conv=_conversion_factors[index];
	width=width*conv;
	height=height*conv;
	
	widthLine->setText(QString().setNum(width));
	heightLine->setText(QString().setNum(height));
	
	previous_units=index;
}

void PlotConfig::pageDPIChanged(int index)
{
	double _conversion_factors[5]={getCurrentDPI(),1,2.54,25.4,getCurrentDPI()};
	double new_dpi=_conversion_factors[unitsCombo->currentItem()];
	
	double ratio=new_dpi/previous_dpi;
	
	if(ratio!=1. && (unitsCombo->currentItem()==0 || unitsCombo->currentItem()==4))
	{
		double width=widthLine->text().toDouble();
		double height=heightLine->text().toDouble();
		widthLine->setText(QString().setNum(width*ratio));
		heightLine->setText(QString().setNum(height*ratio));
	}
	
	previous_dpi=new_dpi;
}

double PlotConfig::getCurrentDPI()
{
	double dpi;
	switch(pageDPICombo->currentItem())
	{
		case 1: dpi=150.; break;
		case 2: dpi=300.; break;
		case 3: dpi=600.; break;
		default: dpi=72.; break;
	}
	return dpi;
}

