#include "StringTokenizer.h"
#include "StringMem.h"

namespace QDOS {

StringTokenizer::StringTokenizer(char const *cp, char const *delimiters):\
  _str(0),_subString(0),_n(0)
{
    _str = StringMem::strdup(cp);

    register char
        *ptr = _str;
    register int len;
    
    
    if(NULL!=strchr(delimiters,*ptr))
    {
      StringMem::realloc(&_subString, sizeof(SubString),0,1);
      _subString[0]._str = ptr;  
      _subString[0]._length = 0;   
      _n+=1;
    }

    while (*(ptr += strspn(ptr, delimiters)))   // go to the begin of the
    {                                           // next substring
        StringMem::realloc(&_subString, sizeof(SubString), _n, _n + 1);
        _subString[_n]._str = ptr;                 // point to 1st char
        len = strcspn(ptr, delimiters);         // compute length of string
        _subString[_n]._length = len;              // store the length
        ptr += len;                             // ptr beyond the string

	_n+=1;
    }
}

char *StringTokenizer::operator[](unsigned index)
{
    if (index >= _n)
        return 0;

    return StringMem::strndup(_subString[index]._str, _subString[index]._length);
}
} // namespace QDOS
